#!/bin/bash

echo -e "\nThis is a helper program that will tentatively check for missing requirements.\n";

echo -n "Make sure to download the ";
content=$(/usr/bin/python -V  2>&1);

if [[ "${content}" =~ "Python 2.4" ]];
then
	echo -n "EL5";
else
	echo -n "EL6";
fi

echo -e " installation file.\n";

echo "Checking CURL SSL...";

curlssl_result=$(/usr/local/bin/php -i|grep -A14 -i "cURL support"|grep SSL|wc -l);

if [[ $curlssl_result -lt "1" ]]
then
	echo "Checking CURL SSL...MISSING";
	exit 1;
fi

echo -e "Checking CURL SSL...GOOD!\n";

echo "Checking zlib compression php.ini...";

php_zlib=$(grep output_compression /usr/local/lib/php.ini|grep -i off|wc -l)

if [[ "${php_zlib}" -ne "1" ]];
then
	echo "Checking zlib compression php.ini...BAD! set zlib.output_compression off";
fi

echo -e "Checking zlib compression php.ini...GOOD!\n";

echo "Checking license activation..."
if [[ ! -f ./unixyvarnish.license ]];
then
	echo "Checking license activation...MISSING unixyvarnish.license file!";
	exit 1;
fi

licensecheck=$(python fs_x86_64/cpanel/scripts/checklicense|grep Active|wc -l);

if [[ "${licensecheck}" -lt "1" ]];
then
	echo "Checking license activation...FAILED! Verify your license key is correct and active in your client area. Errors reported: ";
	tail -30 ./error_log;
	exit 1;
fi

echo "Checking license activation...GOOD"

echo;
