<?php

include("/usr/local/cpanel/php/cpanel.php");

define(BUF_SIZ, 2048);        # max buffer size
define(FD_WRITE, 0);        # stdin
define(FD_READ, 1);        # stdout
define(FD_ERR, 2);        # stderr


function get_line_with_string($file_name, $str) {
    $lines = file($file_name);
    foreach ($lines as $lineNumber => $line) {
        if (strpos($line, $str) !== false) {
            return $line;
        }
    }
    return "";
}

function get_line_with_exact_match($file_name, $str) {
    $lines = file($file_name);
    foreach ($lines as $lineNumber => $line) {
	$newline = explode(':', $line);
        if (strcmp($newline[0], $str) == 0) {
            return $line;
        }
    }
    return "";
}   

function get_subset_array_from_file($file_name, $dom_tuple) {
	$lines = file($file_name);
	$newlines = array();
	foreach ($lines as $line) {
		$newline = explode(':', trim($line));
		$dom = explode(':', $dom_tuple);
		if(strcmp($newline[0], $dom[0]) == 0) {
			continue;
		}
		array_push($newlines, trim($line));
	}
	array_push($newlines, $dom_tuple);
	return $newlines;
}


function get_line_with_exact_match_xsplit($file_name, $str) {
    $lines = file($file_name);
    foreach ($lines as $lineNumber => $line) {
        if (strcmp(trim($line), $str) == 0) {
            return $line;
        }
    }
    return "";
}



function proc_exec($cmd, &$out)
{
    $descriptorspec = array(
        0 => array("pipe", "r"),
        1 => array("pipe", "w"),
        2 => array("pipe", "w")
    );
    $ptr = proc_open($cmd, $descriptorspec, $pipes, NULL, $_ENV);
    if (!is_resource($ptr))
        return false;

    while (($buffer = fgets($pipes[FD_READ], BUF_SIZ)) != NULL
            || ($errbuf = fgets($pipes[FD_ERR], BUF_SIZ)) != NULL) {
        if (!isset($flag)) {
            $pstatus = proc_get_status($ptr);
            $first_exitcode = $pstatus["exitcode"];
            $flag = true;
        }
        if (strlen($buffer))
		$out = $buffer;
        if (strlen($errbuf))
            echo "ERR: " . $errbuf;
    }

    foreach ($pipes as $pipe)
        fclose($pipe);

    /* Get the expected *exit* code to return the value */
    $pstatus = proc_get_status($ptr);
    if (!strlen($pstatus["exitcode"]) || $pstatus["running"]) {
        /* we can trust the retval of proc_close() */
        if ($pstatus["running"])
            proc_terminate($ptr);
        $ret = proc_close($ptr);
    } else {
        if ((($first_exitcode + 256) % 256) == 255
                && (($pstatus["exitcode"] + 256) % 256) != 255)
            $ret = $pstatus["exitcode"];
        elseif (!strlen($first_exitcode))
            $ret = $pstatus["exitcode"];
        elseif ((($first_exitcode + 256) % 256) != 255)
            $ret = $first_exitcode;
        else
            $ret = 0; /* we "deduce" an EXIT_SUCCESS ;) */
        proc_close($ptr);
    }

    return $buffer;
}


function tune_varnish($action, &$out){

        proc_exec($action, $out);
}

function retrieve_current_ttl(&$out) {
        tune_varnish("/usr/bin/python /scripts/getttl", $out);
}

function retrieve_current_static_ttl(&$out) {
        tune_varnish("/usr/bin/python /scripts/getstaticttl", $out);
}



$cpanel = &new CPANEL();

$res = $cpanel->api1('Branding', 'include', array('stdheader.html') );
print $res['cpanelresult']['data']['result'];

$user=array($_SERVER['REMOTE_USER']);

$doms_list = array();

$doms1 = $cpanel->api2("DomainLookup","getbasedomains", $user);
for ($i = 0; $i < sizeof($doms1["cpanelresult"]["data"]) ; $i++) {
        array_push($doms_list, $doms1["cpanelresult"]["data"][$i]["domain"]);
}

$doms2 = $cpanel->api2("SubDomain", "listsubdomains", $user);
for ($i = 0; $i < sizeof($doms2["cpanelresult"]["data"]) ; $i++) {
        array_push($doms_list, $doms2["cpanelresult"]["data"][$i]["domain"]);
}

$dom_count = sizeof($doms_list);

$server_varnish_home = "/etc/varnish";
$server_varnish_dynamic_ttl = '';
$server_varnish_static_ttl = '';
retrieve_current_static_ttl($server_varnish_static_ttl);
retrieve_current_ttl($server_varnish_dynamic_ttl);

$varnish_home = $_SERVER['HOME'] . "/varnish";
$varnish_go = "$varnish_home/process.go";
$varnish_disabled = "$varnish_home/disable_domains.txt";
$varnish_dynamic_ttl = "$varnish_home/dynamic_ttl.txt";
$varnish_static_ttl = "$varnish_home/static_ttl.txt";

$h = fopen($varnish_disabled, "r");
if($h) {
        $all_disabled_domains = fread($h, filesize($varnish_disabled));
}
fclose($h);

$all_varnish_ttl = '';

if (file_exists($varnish_dynamic_ttl)) {
	$h = fopen($varnish_dynamic_ttl, "r");
	if ($h) {
		if (filesize($varnish_dynamic_ttl) > 0) {
			$all_varnish_dynamic_ttl = fread($h, filesize($varnish_dynamic_ttl));
		}
		else {
			$all_varnish_dynamic_ttl = '\n';
		}
	}
	fclose($h);
}

if (file_exists($varnish_static_ttl)) {
	$h = fopen($varnish_static_ttl, "r");
	if ($h) {
		if (filesize($varnish_static_ttl) > 0) {
			$all_varnish_static_ttl = fread($h, filesize($varnish_static_ttl));
		}
		else {
			$all_varnish_static_ttl = '\n';
		}
	}
	fclose($h);
}

$all_varnish_ttl = $all_varnish_dynamic_ttl . $all_varnish_static_ttl;

if(isset($_POST) && sizeof($_POST) > 0) {

	$static_array = array();
	$dynamic_array = array();
	foreach ($_POST as $key => $item) {
		if (strlen(stristr($key, "-static")) > 0) {
			$val = str_replace('_', '.', str_replace("-static", '', $key));
			array_push($static_array, $val.':'. trim($item));
		}
		else if (strlen(stristr($key, "-dynamic")) > 0) {
                        $val = str_replace('_', '.', str_replace("-dynamic", '', $key));
                        array_push($dynamic_array, $val.':'. trim($item));
		}
	}

	if (!is_dir($varnish_home)) { mkdir($varnish_home);}

	$final_static_array = get_subset_array_from_file($varnish_static_ttl, $static_array[0]);
	$final_dynamic_array = get_subset_array_from_file($varnish_dynamic_ttl, $dynamic_array[0]);

	$static = fopen($varnish_static_ttl, "w+");
	if ($static) {
		foreach($final_static_array as $entry) {
			if (strlen($entry) > 0) {
				fwrite($static, trim($entry) . "\n");
			}
		}
	}
	fclose($static);

        $dynamic = fopen($varnish_dynamic_ttl, "w+");
        if ($dynamic) {
                foreach($final_dynamic_array as $entry) {
			if (strlen($entry) > 0) {
                        	fwrite($dynamic, trim($entry) . "\n");
			}
                }
        }
        fclose($dynamic);

	if (sizeof($static_array) > 0 || sizeof($dynamic_array) > 0) {
                $hh = fopen($varnish_go, "w+");
                if ($hh) {
                        fwrite($hh, "go");
                }
                fclose($hh);
	}
}

?>
<?php include("UNIXyVarnish.menu.html"); ?>

<div class="body-content">
<center><h1>Adjust Varnish Caching</h1></center>
</div>

<center>
<table border="1" style="background-color:white;border:1px dotted black;width:80%;border-collapse:collapse; padding-left: 30px;">
<tr style="background-color:orange;color:white;">
<th style="padding:3px;">Domain</th><th style="padding:3px;">Caching Status</th>
<th style="padding:3px;">Static / File TTL (mns) </th>
<th style="padding:3px;">Dynamic / Page TTL (s) </th>
<th style="padding:10px;">Change</th>
</tr>
<?

for ($i = 0; $i < $dom_count; $i++) {

echo sprintf("<form method=\"post\" action=\"%s\">", $_SERVER['SCRIPT_NAME']);
$dom = $doms_list[$i];

if ( substr($dom, 0, 5) === "mail." || substr($dom, 0, 4) === "ftp." || substr($dom, 0, 2) === "*.") {
        continue;
}

// match exact disabled domain name (avoid yo.com and ayo.com matching)
if (strlen(get_line_with_exact_match_xsplit($varnish_disabled, trim($dom))) > 0) {
        $disabled = "<font color=\"Red\">Disabled</front>";
        $disabled_checked="CHECKED";
        $server_default="";
	continue;
}
else if (strlen(get_line_with_exact_match($varnish_static_ttl, $dom)) > 0  || strlen(get_line_with_exact_match($varnish_dynamic_ttl, $dom)) >  0) {
	$disabled = "<font color=\"blue\">User Setting</color>";
	$disabled_checked="";
	$server_default="";
}
else {
        $disabled = "<font color=\"green\">Server Default</font>";
        $disabled_checked="";    
        $server_default="CHECKED";
	$static_ttl = $server_varnish_static_ttl;
}

if (strlen($server_default) > 0) {

print("<tr>");
echo sprintf("<td style=\"padding:3px;\"><b><a target=\"_blank\" href=\"http://%s\">%s</a></b></td><td style=\"padding:3px;\">%s</td> <td style=\"padding:3px;\"><input min=\"0\" max=\"86640\" type=\"number\" name=\"%s-static\" value=\"%d\" %s /> </td><td><input min=\"0\" max=\"86640\" type=\"number\" name=\"%s-dynamic\" value=\"%s\" %s /></td><td style=\"padding: 6px;\"><input type=\"submit\" name=\"Change\" /></td>", $dom, $dom, $disabled, $dom, $server_varnish_static_ttl, $disabled_checked, $dom, $server_varnish_dynamic_ttl, $server_default);
print("</tr>");
}
else if (strlen($server_default) <= 0){

$static_ttl_line = get_line_with_exact_match($varnish_static_ttl, $dom);
$dynamic_ttl_line = get_line_with_exact_match($varnish_dynamic_ttl, $dom);

$custom_static_ttl = 0;
$custom_dynamic_ttl = 0;

if (strlen($static_ttl_line) <= 0) {
	$custom_static_ttl = $server_varnish_static_ttl;
} else {
	$arr= explode(':', $static_ttl_line);
	$custom_static_ttl = $arr[1];
}

if (strlen($dynamic_ttl_line) <= 0) {
        $custom_dynamic_ttl = $server_varnish_dynamic_ttl;
} else {
        $arr= explode(':', $dynamic_ttl_line);
        $custom_dynamic_ttl = $arr[1];
}


print("<tr>");
echo sprintf("<td style=\"padding:3px;\"><b><a target=\"_blank\" href=\"http://%s\">%s</a></b></td><td style=\"padding:3px;\">%s</td> <td style=\"padding:3px;\"><input min=\"0\" max=\"86640\" type=\"number\" name=\"%s-static\" value=\"%d\" %s /> </td><td><input min=\"0\" max=\"86640\" type=\"number\" name=\"%s-dynamic\" value=\"%d\" %s /></td><td style=\"padding: 3px;\"><input type=\"submit\" name=\"Change\" /></td>", $dom, $dom, $disabled, $dom, $custom_static_ttl, $disabled_checked, $dom, $custom_dynamic_ttl, $server_default);
print("</tr>");
}
echo "</form>";
}
?>
</table>
<br />
<!-- <input type="submit" name="Change" /> -->
</center>
<br /><br />
<center>Changes made do NOT take effect immediately. Check with support on run frequency.</center>
<br /><br />
<?php
$res = $cpanel->api1('Branding', 'include', array('stdfooter.html') );
print $res['cpanelresult']['data']['result'];
$cpanel->end();
